
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>controller.validation module &#8212; DataMAx 0.1 documentation</title>
    <link rel="stylesheet" href="_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">DataMAx 0.1 documentation</a> &#187;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-controller.validation">
<span id="controller-validation-module"></span><h1>controller.validation module<a class="headerlink" href="#module-controller.validation" title="Permalink to this headline">¶</a></h1>
<dl class="function">
<dt id="controller.validation.index">
<code class="sig-prename descclassname">controller.validation.</code><code class="sig-name descname">index</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.validation.index" title="Permalink to this definition">¶</a></dt>
<dd></dd></dl>

<dl class="function">
<dt id="controller.validation.validation_at_redshift">
<code class="sig-prename descclassname">controller.validation.</code><code class="sig-name descname">validation_at_redshift</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.validation.validation_at_redshift" title="Permalink to this definition">¶</a></dt>
<dd><p>Run validation on Redshift using metadata from postgres db.</p>
<p>Validation engine service will receive the configuration via service call to the along with the
target table and target schema name on which the validation rules have to be applied.
This engine is responsible for fetching the configuration based on <cite>config_id</cite> received.
Once done, it will populate the record in <code class="docutils literal notranslate"><span class="pre">summary</span></code> table for a given profile which will have all
the meta data about the instance run.
For example, the time taken and no. of records passed/failed. It will also have <code class="docutils literal notranslate"><span class="pre">details</span></code>
table which will have all the <code class="docutils literal notranslate"><span class="pre">DMX_ID</span></code> which have failed for the given run.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>rs_connector_id</strong> (<em>int</em>) – to assign the Redshift resource to be used for the execution.</p></li>
<li><p><strong>config_id</strong> (<em>int</em>) – the configuration id already present in the system, required to run the validations</p></li>
<li><p><strong>target_table</strong> (<em>string</em>) – [Optional] table on which the validation has to be executed</p></li>
<li><p><strong>target_schema</strong> (<em>string</em>) – [Optional] target schema</p></li>
<li><p><strong>detail_schema</strong> (<em>string</em>) – schema in which the detailed table is created to store the failed records</p></li>
<li><p><strong>config_instance_id</strong> (<em>int</em>) – [Optional] to be provided to chain the validation engine request. In case
provided, it expects a <cite>stage</cite> no. which will uniquely identify the instance.</p></li>
<li><p><strong>stage</strong> (<em>int</em>) – [Optional] in case of chained subsets of validations, mention the stage at which it has
to be executed.</p></li>
<li><p><strong>rule_type</strong> (<em>string</em>) – [Optional] default has been set to <cite>user_defined</cite>.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>which has the <code class="docutils literal notranslate"><span class="pre">id</span></code> of the validation instance run.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>Run a single validation rule using the config id</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/validation/redshift?rs_connector_id=12&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&amp;config_id=10&amp;target_table=s3_e8f3658a7d6c40eeb2efc2076d969d3a&amp;target_schema=source&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;config_instance&quot;: [</span>
<span class="go">    {</span>
<span class="go">      &quot;config_id&quot;: 10,</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;detail_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;detail_table_name&quot;: &quot;s3_e8f3658a7d6c40eeb2efc2076d969d3a_detail_4&quot;,</span>
<span class="go">      &quot;end_date&quot;: &quot;Sat, 18 May 2019 22:04:16 GMT&quot;,</span>
<span class="go">      &quot;fail_count&quot;: null,</span>
<span class="go">      &quot;failure_schema_name&quot;: null,</span>
<span class="go">      &quot;failure_table_name&quot;: null,</span>
<span class="go">      &quot;id&quot;: 4,</span>
<span class="go">      &quot;start_date&quot;: &quot;Sat, 18 May 2019 22:04:05 GMT&quot;,</span>
<span class="go">      &quot;status&quot;: &quot;Completed&quot;,</span>
<span class="go">      &quot;success_count&quot;: null,</span>
<span class="go">      &quot;success_schema_name&quot;: null,</span>
<span class="go">      &quot;success_table_name&quot;: null,</span>
<span class="go">      &quot;target_schema&quot;: &quot;source&quot;,</span>
<span class="go">      &quot;target_table&quot;: &quot;s3_e8f3658a7d6c40eeb2efc2076d969d3a&quot;</span>
<span class="go">    }</span>
<span class="go">  ],</span>
<span class="go">  &quot;rule_instance&quot;: [</span>
<span class="go">    {</span>
<span class="go">      &quot;config_instance_id&quot;: 4,</span>
<span class="go">      &quot;end_date&quot;: &quot;Sat, 18 May 2019 22:04:14 GMT&quot;,</span>
<span class="go">      &quot;fail_count&quot;: 24,</span>
<span class="go">      &quot;id&quot;: 4,</span>
<span class="go">      &quot;query&quot;: &quot;SELECT dmx_id, FALSE as status, &#39;&#39; as message FROM source.s3_e8f3658a7d6c40eeb2efc2076d969d3a where not( length(market_id) = 6)&quot;,</span>
<span class="go">      &quot;rule_id&quot;: 1009,</span>
<span class="go">      &quot;sequence&quot;: 0,</span>
<span class="go">      &quot;start_date&quot;: &quot;Sat, 18 May 2019 22:04:15 GMT&quot;,</span>
<span class="go">      &quot;status&quot;: &quot;Completed&quot;</span>
<span class="go">    }</span>
<span class="go">  ]</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.validation.validation_at_s3">
<code class="sig-prename descclassname">controller.validation.</code><code class="sig-name descname">validation_at_s3</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.validation.validation_at_s3" title="Permalink to this definition">¶</a></dt>
<dd><p>Run validation on S3 file without scanning the complete file.</p>
<p>The service called upon will run the pre-processing rules at S3 layer. Example, check for duplicate
column name, which will raise exception in data movement as the table cannot have same column names.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>s3_connector_id</strong> (<em>int</em>) – to assign the S3 resource to be used for the execution.</p></li>
<li><p><strong>config_id</strong> (<em>int</em>) – the configuration id already present in the system, required to run the validations</p></li>
<li><p><strong>target_bucket</strong> (<em>string</em>) – target bucket</p></li>
<li><p><strong>target_file_path</strong> (<em>string</em>) – target file path with extension, currently supporting TEXTFILE.</p></li>
<li><p><strong>config_instance_id</strong> (<em>int</em>) – [Optional] to be provided to chain the validation engine request. In case
provided, it expects a <cite>stage</cite> no. which will uniquely identify the instance.</p></li>
<li><p><strong>stage</strong> (<em>int</em>) – [Optional] in case of chained subsets of validations, mention the stage at which it has
to be executed.</p></li>
<li><p><strong>rule_type</strong> (<em>string</em>) – [Optional] default has been set to <cite>user_defined</cite>.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>which has the <code class="docutils literal notranslate"><span class="pre">id</span></code> of the validation instance run.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>Check for duplicate columns and sequence of the column using validation service at S3.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://127.0.0.1:5000/api/validation/s3?s3_connector_id=12&amp;config_id=30&#39;</span>
<span class="gp">... </span>       <span class="s1">&#39;&amp;target_bucket=datamax1&amp;target_file_path=poc/symphony_sales/Symphony_Sales.csv&amp;stage=1&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;config_instance&quot;: [</span>
<span class="go">    {</span>
<span class="go">      &quot;config_id&quot;: 6,</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;detail_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;detail_table_name&quot;: &quot;s3_e8f3658a7d6c40eeb2efc2076d969d3a_detail_4&quot;,</span>
<span class="go">      &quot;end_date&quot;: &quot;Sat, 18 May 2019 22:04:16 GMT&quot;,</span>
<span class="go">      &quot;fail_count&quot;: null,</span>
<span class="go">      &quot;failure_schema_name&quot;: null,</span>
<span class="go">      &quot;failure_table_name&quot;: null,</span>
<span class="go">      &quot;id&quot;: 4,</span>
<span class="go">      &quot;start_date&quot;: &quot;Sat, 18 May 2019 22:04:05 GMT&quot;,</span>
<span class="go">      &quot;status&quot;: &quot;Completed&quot;,</span>
<span class="go">      &quot;success_count&quot;: null,</span>
<span class="go">      &quot;success_schema_name&quot;: null,</span>
<span class="go">      &quot;success_table_name&quot;: null,</span>
<span class="go">      &quot;target_schema&quot;: &quot;source&quot;,</span>
<span class="go">      &quot;target_table&quot;: &quot;s3_e8f3658a7d6c40eeb2efc2076d969d3a&quot;</span>
<span class="go">    }</span>
<span class="go">  ],</span>
<span class="go">  &quot;rule_instance&quot;: [</span>
<span class="go">    {</span>
<span class="go">      &quot;config_instance_id&quot;: 4,</span>
<span class="go">      &quot;end_date&quot;: &quot;Sat, 18 May 2019 22:04:14 GMT&quot;,</span>
<span class="go">      &quot;fail_count&quot;: 24,</span>
<span class="go">      &quot;id&quot;: 4,</span>
<span class="go">      &quot;query&quot;: &quot;SELECT dmx_id, FALSE as status, &#39;&#39; as message FROM source.s3_e8f3658a7d6c40eeb2efc2076d969d3a where not( length(market_id) = 6)&quot;,</span>
<span class="go">      &quot;rule_id&quot;: 1009,</span>
<span class="go">      &quot;sequence&quot;: 0,</span>
<span class="go">      &quot;start_date&quot;: &quot;Sat, 18 May 2019 22:04:15 GMT&quot;,</span>
<span class="go">      &quot;status&quot;: &quot;Completed&quot;</span>
<span class="go">    }</span>
<span class="go">  ]</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.validation.validation_end_to_end">
<code class="sig-prename descclassname">controller.validation.</code><code class="sig-name descname">validation_end_to_end</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.validation.validation_end_to_end" title="Permalink to this definition">¶</a></dt>
<dd><p>Run the validation at both Redshift and S3 layer.</p>
<p>Parameters:</p>
<p>Examples:</p>
</dd></dl>

<dl class="function">
<dt id="controller.validation.success_records">
<code class="sig-prename descclassname">controller.validation.</code><code class="sig-name descname">success_records</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.validation.success_records" title="Permalink to this definition">¶</a></dt>
<dd><p>Publish the success records for the given run.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>rs_connector_id</strong> (<em>string</em>) – to assign the Redshift resource to be used for the execution.</p></li>
<li><p><strong>config_instance_id</strong> (<em>int</em>) – the instance id which is used to reference the previous runs.</p></li>
<li><p><strong>success_schema</strong> (<em>string</em>) – [Optional] default has been set to <cite>validation</cite>.</p></li>
<li><p><strong>stage</strong> (<em>int</em>) – [Optional] default has been set to 1, in case of chained validations for different instances
they can be identified by the stage no. provided.</p></li>
<li><p><strong>success_table</strong> (<em>string</em>) – [Optional] default is created at runtime using the format
<cite>tablename_success_&lt;config_instance_id&gt;</cite></p></li>
<li><p><strong>dtypes</strong> (<em>JSON</em>) – [Optional] if provided will create the success table with the given data type in redshift.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>which has a boolean to show the status of successfully published the success records into the S3.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/validation/success_records?rs_connector_id=12&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&amp;config_instance_id=18&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;config_instance&quot;: [</span>
<span class="go">    {</span>
<span class="go">      &quot;config_id&quot;: 32,</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;detail_schema_name&quot;: null,</span>
<span class="go">      &quot;detail_table_name&quot;: &quot;poc/symphony_sales/Symphony_Sales.csv_detail_31&quot;,</span>
<span class="go">      &quot;end_date&quot;: &quot;Fri, 31 May 2019 17:16:43 GMT&quot;,</span>
<span class="go">      &quot;fail_count&quot;: 1,</span>
<span class="go">      &quot;failure_schema_name&quot;: null,</span>
<span class="go">      &quot;failure_table_name&quot;: null,</span>
<span class="go">      &quot;id&quot;: 31,</span>
<span class="go">      &quot;rule_type&quot;: &quot;user_defined&quot;,</span>
<span class="go">      &quot;stage&quot;: 1,</span>
<span class="go">      &quot;start_date&quot;: &quot;Fri, 31 May 2019 17:16:23 GMT&quot;,</span>
<span class="go">      &quot;status&quot;: &quot;Completed&quot;,</span>
<span class="go">      &quot;success_count&quot;: NaN,</span>
<span class="go">      &quot;success_schema_name&quot;: null,</span>
<span class="go">      &quot;success_table_name&quot;: null,</span>
<span class="go">      &quot;target_schema&quot;: &quot;datamax1&quot;,</span>
<span class="go">      &quot;target_table&quot;: &quot;poc/symphony_sales/Symphony_Sales.csv&quot;,</span>
<span class="go">      &quot;total_count&quot;: NaN</span>
<span class="go">    },</span>
<span class="go">    {</span>
<span class="go">      &quot;config_id&quot;: 32,</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;detail_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;detail_table_name&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198_detail_31&quot;,</span>
<span class="go">      &quot;end_date&quot;: &quot;Fri, 31 May 2019 17:17:53 GMT&quot;,</span>
<span class="go">      &quot;fail_count&quot;: 0,</span>
<span class="go">      &quot;failure_schema_name&quot;: null,</span>
<span class="go">      &quot;failure_table_name&quot;: null,</span>
<span class="go">      &quot;id&quot;: 31,</span>
<span class="go">      &quot;rule_type&quot;: &quot;system_defined&quot;,</span>
<span class="go">      &quot;stage&quot;: 2,</span>
<span class="go">      &quot;start_date&quot;: &quot;Fri, 31 May 2019 17:17:16 GMT&quot;,</span>
<span class="go">      &quot;status&quot;: &quot;Completed&quot;,</span>
<span class="go">      &quot;success_count&quot;: 24.0,</span>
<span class="go">      &quot;success_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;success_table_name&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198&quot;,</span>
<span class="go">      &quot;target_schema&quot;: &quot;temp&quot;,</span>
<span class="go">      &quot;target_table&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198&quot;,</span>
<span class="go">      &quot;total_count&quot;: 24.0</span>
<span class="go">    },</span>
<span class="go">    {</span>
<span class="go">      &quot;config_id&quot;: 32,</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;detail_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;detail_table_name&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198_detail_31&quot;,</span>
<span class="go">      &quot;end_date&quot;: &quot;Fri, 31 May 2019 17:18:52 GMT&quot;,</span>
<span class="go">      &quot;fail_count&quot;: 1,</span>
<span class="go">      &quot;failure_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;failure_table_name&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198_failed_31&quot;,</span>
<span class="go">      &quot;id&quot;: 31,</span>
<span class="go">      &quot;rule_type&quot;: &quot;user_defined&quot;,</span>
<span class="go">      &quot;stage&quot;: 3,</span>
<span class="go">      &quot;start_date&quot;: &quot;Fri, 31 May 2019 17:18:34 GMT&quot;,</span>
<span class="go">      &quot;status&quot;: &quot;Completed&quot;,</span>
<span class="go">      &quot;success_count&quot;: 23.0,</span>
<span class="go">      &quot;success_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;success_table_name&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198_success_31&quot;,</span>
<span class="go">      &quot;target_schema&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;target_table&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198&quot;,</span>
<span class="go">      &quot;total_count&quot;: 24.0</span>
<span class="go">    }</span>
<span class="go">  ]</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.validation.failed_records">
<code class="sig-prename descclassname">controller.validation.</code><code class="sig-name descname">failed_records</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.validation.failed_records" title="Permalink to this definition">¶</a></dt>
<dd><p>Publish the failed records for the given run.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>rs_connector_id</strong> (<em>int</em>) – to assign the Redshift resource to be used for the execution.</p></li>
<li><p><strong>instance_id</strong> (<em>int</em>) – the instance id which is used to reference the previous runs.</p></li>
<li><p><strong>success_schema</strong> (<em>string</em>) – [Optional] default has been set to <cite>validation</cite>.</p></li>
<li><p><strong>stage</strong> (<em>int</em>) – [Optional] default has been set to 1, in case of chained validations for different instances
they can be identified by the stage no. provided.</p></li>
<li><p><strong>failed_table</strong> (<em>string</em>) – [Optional] default is created at runtime using the format
<cite>tablename_failed_&lt;config_instance_id&gt;</cite></p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>which has a boolean to show the status of successfully published the failed records into the S3.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5000/api/validation/failed_records?rs_connector_id=12&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&amp;config_instance_id=18&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;config_instance&quot;: [</span>
<span class="go">    {</span>
<span class="go">      &quot;config_id&quot;: 32,</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;detail_schema_name&quot;: null,</span>
<span class="go">      &quot;detail_table_name&quot;: &quot;poc/symphony_sales/Symphony_Sales.csv_detail_31&quot;,</span>
<span class="go">      &quot;end_date&quot;: &quot;Fri, 31 May 2019 17:16:43 GMT&quot;,</span>
<span class="go">      &quot;fail_count&quot;: 1,</span>
<span class="go">      &quot;failure_schema_name&quot;: null,</span>
<span class="go">      &quot;failure_table_name&quot;: null,</span>
<span class="go">      &quot;id&quot;: 31,</span>
<span class="go">      &quot;rule_type&quot;: &quot;user_defined&quot;,</span>
<span class="go">      &quot;stage&quot;: 1,</span>
<span class="go">      &quot;start_date&quot;: &quot;Fri, 31 May 2019 17:16:23 GMT&quot;,</span>
<span class="go">      &quot;status&quot;: &quot;Completed&quot;,</span>
<span class="go">      &quot;success_count&quot;: NaN,</span>
<span class="go">      &quot;success_schema_name&quot;: null,</span>
<span class="go">      &quot;success_table_name&quot;: null,</span>
<span class="go">      &quot;target_schema&quot;: &quot;datamax1&quot;,</span>
<span class="go">      &quot;target_table&quot;: &quot;poc/symphony_sales/Symphony_Sales.csv&quot;,</span>
<span class="go">      &quot;total_count&quot;: NaN</span>
<span class="go">    },</span>
<span class="go">    {</span>
<span class="go">      &quot;config_id&quot;: 32,</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;detail_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;detail_table_name&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198_detail_31&quot;,</span>
<span class="go">      &quot;end_date&quot;: &quot;Fri, 31 May 2019 17:17:53 GMT&quot;,</span>
<span class="go">      &quot;fail_count&quot;: 0,</span>
<span class="go">      &quot;failure_schema_name&quot;: null,</span>
<span class="go">      &quot;failure_table_name&quot;: null,</span>
<span class="go">      &quot;id&quot;: 31,</span>
<span class="go">      &quot;rule_type&quot;: &quot;system_defined&quot;,</span>
<span class="go">      &quot;stage&quot;: 2,</span>
<span class="go">      &quot;start_date&quot;: &quot;Fri, 31 May 2019 17:17:16 GMT&quot;,</span>
<span class="go">      &quot;status&quot;: &quot;Completed&quot;,</span>
<span class="go">      &quot;success_count&quot;: 24.0,</span>
<span class="go">      &quot;success_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;success_table_name&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198&quot;,</span>
<span class="go">      &quot;target_schema&quot;: &quot;temp&quot;,</span>
<span class="go">      &quot;target_table&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198&quot;,</span>
<span class="go">      &quot;total_count&quot;: 24.0</span>
<span class="go">    },</span>
<span class="go">    {</span>
<span class="go">      &quot;config_id&quot;: 32,</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;detail_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;detail_table_name&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198_detail_31&quot;,</span>
<span class="go">      &quot;end_date&quot;: &quot;Fri, 31 May 2019 17:18:52 GMT&quot;,</span>
<span class="go">      &quot;fail_count&quot;: 1,</span>
<span class="go">      &quot;failure_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;failure_table_name&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198_failed_31&quot;,</span>
<span class="go">      &quot;id&quot;: 31,</span>
<span class="go">      &quot;rule_type&quot;: &quot;user_defined&quot;,</span>
<span class="go">      &quot;stage&quot;: 3,</span>
<span class="go">      &quot;start_date&quot;: &quot;Fri, 31 May 2019 17:18:34 GMT&quot;,</span>
<span class="go">      &quot;status&quot;: &quot;Completed&quot;,</span>
<span class="go">      &quot;success_count&quot;: 23.0,</span>
<span class="go">      &quot;success_schema_name&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;success_table_name&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198_success_31&quot;,</span>
<span class="go">      &quot;target_schema&quot;: &quot;validation&quot;,</span>
<span class="go">      &quot;target_table&quot;: &quot;s3_807d3fe81ccc41f9bb6517b01ae7c198&quot;,</span>
<span class="go">      &quot;total_count&quot;: 24.0</span>
<span class="go">    }</span>
<span class="go">  ]</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.validation.failed_records_tos3">
<code class="sig-prename descclassname">controller.validation.</code><code class="sig-name descname">failed_records_tos3</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.validation.failed_records_tos3" title="Permalink to this definition">¶</a></dt>
<dd><p>Run the validaiton and export failed records to s3.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>rs_connector_id</strong> (<em>int</em>) – to assign the Redshift resource to be used for the execution.</p></li>
<li><p><strong>s3_connector_id</strong> (<em>int</em>) – to assign the S3 resource to be used for the execution.</p></li>
<li><p><strong>config_id</strong> (<em>int</em>) – the configuration id already present in the system, required to run the validations</p></li>
<li><p><strong>target_table</strong> (<em>string</em>) – [Optional] table on which the validation has to be executed</p></li>
<li><p><strong>target_schema</strong> (<em>string</em>) – [Optional] target schema</p></li>
<li><p><strong>detail_schema</strong> (<em>string</em>) – schema in which the detailed table is created to store the failed records</p></li>
<li><p><strong>destination_bucket</strong> (<em>string</em>) – S3 bucket name</p></li>
<li><p><strong>destination_object</strong> (<em>string</em>) – folder path into which the file has to be dumped</p></li>
<li><p><strong>parallel</strong> (<em>string</em>) – [Optional] to save the file on s3 parellely</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>Examples:</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>JSON</p>
</dd>
</dl>
<p>To dump multiple files (parallel fashion) having the header object will have a request format.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;http://localhost:5000/api/redshift/failedrecordstos3?rs_connector_id=12&amp;s3_connector_id=3&amp;&quot;</span>
<span class="gp">... </span>             <span class="s2">&quot;target_schema=source&amp;target_table=source&amp;config_id=1&amp;detail_schema=validation&amp;&quot;</span>
<span class="gp">... </span>             <span class="s2">&quot;destination_bucket=datamax1&amp;destination_object=poc/sample/&amp;parallel=True&quot;</span><span class="p">)</span>
<span class="gp">...</span>
<span class="go">{</span>
<span class="go">  &quot;config_instance&quot;: [</span>
<span class="go">      {</span>
<span class="go">          &quot;config_id&quot;: 299,</span>
<span class="go">          &quot;created_by&quot;: null,</span>
<span class="go">          &quot;detail_schema_name&quot;: &quot;testing_stage&quot;,</span>
<span class="go">          &quot;detail_table_name&quot;: &quot;aft_ddd_wkly_detail_4102&quot;,</span>
<span class="go">          &quot;end_date&quot;: &quot;Tue, 30 Jul 2019 10:21:39 GMT&quot;,</span>
<span class="go">          &quot;fail_count&quot;: 1130322,</span>
<span class="go">          &quot;failure_s3_path&quot;: null,</span>
<span class="go">          &quot;failure_schema_name&quot;: null,</span>
<span class="go">          &quot;failure_table_name&quot;: null,</span>
<span class="go">          &quot;id&quot;: 4102,</span>
<span class="go">          &quot;is_archieved&quot;: false,</span>
<span class="go">          &quot;rule_type&quot;: &quot;user_defined&quot;,</span>
<span class="go">          &quot;stage&quot;: 1,</span>
<span class="go">          &quot;start_date&quot;: &quot;Tue, 30 Jul 2019 10:21:14 GMT&quot;,</span>
<span class="go">          &quot;status&quot;: &quot;Completed&quot;,</span>
<span class="go">          &quot;success_count&quot;: 1891423,</span>
<span class="go">          &quot;success_s3_path&quot;: null,</span>
<span class="go">          &quot;success_schema_name&quot;: null,</span>
<span class="go">          &quot;success_table_name&quot;: null,</span>
<span class="go">          &quot;target_schema&quot;: &quot;testing_stage&quot;,</span>
<span class="go">          &quot;target_table&quot;: &quot;aft_ddd_wkly&quot;</span>
<span class="go">      }</span>
<span class="go">  ],</span>
<span class="go">  &quot;data&quot;: {</span>
<span class="go">      &quot;AcceptRanges&quot;: &quot;bytes&quot;,</span>
<span class="go">      &quot;ContentLength&quot;: 568911069,</span>
<span class="go">      &quot;ContentType&quot;: &quot;application/x-www-form-urlencoded; charset=utf-8&quot;,</span>
<span class="go">      &quot;ETag&quot;: &quot;&quot;2611f3017cfba5e232daac7d1284cb19-9&quot;&quot;,</span>
<span class="go">      &quot;LastModified&quot;: &quot;Tue, 30 Jul 2019 10:22:06 GMT&quot;,</span>
<span class="go">      &quot;Metadata&quot;: {},</span>
<span class="go">      &quot;ResponseMetadata&quot;: {</span>
<span class="go">          &quot;HTTPHeaders&quot;: {</span>
<span class="go">              &quot;accept-ranges&quot;: &quot;bytes&quot;,</span>
<span class="go">              &quot;content-length&quot;: &quot;568911069&quot;,</span>
<span class="go">              &quot;content-type&quot;: &quot;application/x-www-form-urlencoded; charset=utf-8&quot;,</span>
<span class="go">              &quot;date&quot;: &quot;Tue, 30 Jul 2019 10:22:55 GMT&quot;,</span>
<span class="go">              &quot;etag&quot;: &quot;&quot;2611f3017cfba5e232daac7d1284cb19-9&quot;&quot;,</span>
<span class="go">              &quot;last-modified&quot;: &quot;Tue, 30 Jul 2019 10:22:06 GMT&quot;,</span>
<span class="go">              &quot;server&quot;: &quot;AmazonS3&quot;,</span>
<span class="go">              &quot;x-amz-id-2&quot;: &quot;2yOgERE1RmSzDmtZkyx9B//OGo9LvUESRvI1zlXIlEalxREIT60+Z7uOZ9zJOhVyy+iFssdgHPU=&quot;,</span>
<span class="go">              &quot;x-amz-request-id&quot;: &quot;85F391075F6A8DD1&quot;,</span>
<span class="go">              &quot;x-amz-server-side-encryption&quot;: &quot;AES256&quot;</span>
<span class="go">          },</span>
<span class="go">          &quot;HTTPStatusCode&quot;: 200,</span>
<span class="go">          &quot;HostId&quot;: &quot;2yOgERE1RmSzDmtZkyx9B//OGo9LvUESRvI1zlXIlEalxREIT60+Z7uOZ9zJOhVyy+iFssdgHPU=&quot;,</span>
<span class="go">          &quot;RequestId&quot;: &quot;85F391075F6A8DD1&quot;,</span>
<span class="go">          &quot;RetryAttempts&quot;: 0</span>
<span class="go">      },</span>
<span class="go">      &quot;ServerSideEncryption&quot;: &quot;AES256&quot;</span>
<span class="go">  },</span>
<span class="go">  &quot;rule_instance&quot;: [</span>
<span class="go">      {</span>
<span class="go">          &quot;config_instance_id&quot;: 4102,</span>
<span class="go">          &quot;end_date&quot;: &quot;Tue, 30 Jul 2019 10:21:26 GMT&quot;,</span>
<span class="go">          &quot;fail_count&quot;: 0,</span>
<span class="go">          &quot;id&quot;: 9042,</span>
<span class="go">          &quot;query&quot;: &quot;with varformat as (select case when &#39;YYMMDD&#39; =  &#39;YYYY-MM-DD&#39; then &#39;^[0-9][0-9][0-9][0-9]-(((0)[0-9])|((1)[0-2]))-(((0)[0-9])|([1-2][0-9])|([3][0-1]))$&#39; when &#39;YYMMDD&#39; =  &#39;YYYY-DD-MM&#39; then &#39;^[0-9][0-9][0-9][0-9]-(((0)[0-9])|([1-2][0-9])|([3][0-1]))-(((0)[0-9])|((1)[0-2]))$&#39; when &#39;YYMMDD&#39; =  &#39;YYYY/MM/DD&#39; then &#39;^[0-9][0-9][0-9][0-9]/(((0)[0-9])|((1)[0-2]))/(((0)[0-9])|([1-2][0-9])|([3][0-1]))$&#39; when &#39;YYMMDD&#39; =  &#39;YYYY/DD/MM&#39; then &#39;^[0-9][0-9][0-9][0-9]/(((0)[0-9])|([1-2][0-9)|([3][0-1]))/(((0)[0-9])|((1)[0-2]))$&#39; when &#39;YYMMDD&#39; = &#39;DD-MON-YY&#39; then &#39;^(((0)[0-9])|([1-2][0-9])|([3][0-1]))-(JAN(UARY)?|FEB(RUARY)?|MAR(CH)?|APR(IL)?|MAY|JUN(E)?|JUL(Y)?|AUG(UST)?|SEP(TEMBER)?|OCT(OBER)?|NOV(EMBER)?|DEC(EMBER)?)-([0-9][0-9])$&#39; end as format) select dmx_id, FALSE as status, &#39;&#39; as message from testing_stage.aft_ddd_wkly cross join varformat where WEEK_ENDT !~ varformat.format&quot;,</span>
<span class="go">          &quot;rule_id&quot;: 1025,</span>
<span class="go">          &quot;stage&quot;: 1,</span>
<span class="go">          &quot;start_date&quot;: &quot;Tue, 30 Jul 2019 10:21:23 GMT&quot;,</span>
<span class="go">          &quot;status&quot;: &quot;Completed&quot;</span>
<span class="go">      },</span>
<span class="go">      {</span>
<span class="go">          &quot;config_instance_id&quot;: 4102,</span>
<span class="go">          &quot;end_date&quot;: &quot;Tue, 30 Jul 2019 10:21:29 GMT&quot;,</span>
<span class="go">          &quot;fail_count&quot;: 1130322,</span>
<span class="go">          &quot;id&quot;: 9043,</span>
<span class="go">          &quot;query&quot;: &quot;select False  as status,  &#39;&#39; as message, DMX_ID as DMX_ID from  testing_stage.aft_ddd_wkly where sra2 is null or len(trim(sra2)) = 0&quot;,</span>
<span class="go">          &quot;rule_id&quot;: 1035,</span>
<span class="go">          &quot;stage&quot;: 1,</span>
<span class="go">          &quot;start_date&quot;: &quot;Tue, 30 Jul 2019 10:21:27 GMT&quot;,</span>
<span class="go">          &quot;status&quot;: &quot;Completed&quot;</span>
<span class="go">      },</span>
<span class="go">      {</span>
<span class="go">          &quot;config_instance_id&quot;: 4102,</span>
<span class="go">          &quot;end_date&quot;: &quot;Tue, 30 Jul 2019 10:21:33 GMT&quot;,</span>
<span class="go">          &quot;fail_count&quot;: 1130322,</span>
<span class="go">          &quot;id&quot;: 9044,</span>
<span class="go">          &quot;query&quot;: &quot;select False  as status,  &#39;&#39; as message, DMX_ID as DMX_ID from  testing_stage.aft_ddd_wkly where OUTLET_ZIP is null or len(trim(OUTLET_ZIP)) = 0&quot;,</span>
<span class="go">          &quot;rule_id&quot;: 1035,</span>
<span class="go">          &quot;stage&quot;: 1,</span>
<span class="go">          &quot;start_date&quot;: &quot;Tue, 30 Jul 2019 10:21:30 GMT&quot;,</span>
<span class="go">          &quot;status&quot;: &quot;Completed&quot;</span>
<span class="go">      },</span>
<span class="go">      {</span>
<span class="go">          &quot;config_instance_id&quot;: 4102,</span>
<span class="go">          &quot;end_date&quot;: &quot;Tue, 30 Jul 2019 10:21:36 GMT&quot;,</span>
<span class="go">          &quot;fail_count&quot;: 0,</span>
<span class="go">          &quot;id&quot;: 9045,</span>
<span class="go">          &quot;query&quot;: &quot;SELECT dmx_id, FALSE as status, &#39;&#39; as message FROM testing_stage.aft_ddd_wkly where not (length(OUTLET_ZIP) = 5)&quot;,</span>
<span class="go">          &quot;rule_id&quot;: 1009,</span>
<span class="go">          &quot;stage&quot;: 1,</span>
<span class="go">          &quot;start_date&quot;: &quot;Tue, 30 Jul 2019 10:21:34 GMT&quot;,</span>
<span class="go">          &quot;status&quot;: &quot;Completed&quot;</span>
<span class="go">      }</span>
<span class="go">  ]</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/controller.validation.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">DataMAx 0.1 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2019, AxtriaOne.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 2.3.1.
    </div>
  </body>
</html>